#import matplotlib
import numpy as np
import pandas as pd
import bilby
import matplotlib as mpl
#import matplotlib.patches as mpatches
import matplotlib.font_manager
#from colour import Color
#from mpl_toolkits.axes_grid1 import make_axes_locatable
import matplotlib.pyplot as plt
#from matplotlib.colors import LinearSegmentedColormap
plt.rcParams["backend"] = 'GTK3Agg'
plt.text.usetex= True
plt.rcParams["font.family"] = "STIXGeneral"
plt.rcParams["mathtext.fontset"] = "cm"
plt.rcParams["font.size"] =30
plt.rcParams['figure.figsize'] = (11.69,8.27)


def set_axis_style1(ax, labels,labelsR):
    ax.get_xaxis().set_tick_params(direction='in',top=True,grid_alpha=0,which='both',length=9,width=1.2,pad=6)
    ax.get_yaxis().set_tick_params(direction='in',right=True,which='both',grid_alpha=0,length=9,width=1.2,pad=270)
    ax.set_xlabel(r'log$_{\mathrm{10}}(\mathit{M}^{\mathit{z}}_{\mathrm{L}}/\mathit{M}_{\odot})$') 
    ax.yaxis.set_ticks_position('left')
    ax.set_yticks(np.arange(1, len(labels) + 1))
    ax.set_yticklabels(labels,ha='left') #
    ax.set_ylim(0.25, len(labels) + 0.75)
    axR = ax.twinx()
    axR.get_yaxis().set_tick_params(direction='in',left=True,which='both',grid_alpha=0,length=9,width=1.2,pad=55)
    axR.yaxis.set_ticks_position('right')
    axR.set_ylabel(r'log$_{\mathrm{10}}\mathcal{B}^{\mathit{ML}}_{\mathit{U}}$',rotation=270,labelpad=70) 
    axR.set_yticks(np.arange(1, len(labelsR) + 1))
    axR.set_yticklabels(labelsR,ha='right') #,fontsize=36
    axR.set_ylim(0.25, len(labelsR) + 0.75)
    

logmlzpos_t = []    
for i in np.arange(1,37,1):
    a = np.loadtxt(fname=f'Sec_6_Figure_5_MLz_pos_{i}.dat')
    logmlzpos_t.append(a)

#logmlzpos_t = [logmlzpos1,logmlzpos2,logmlzpos3,logmlzpos4, logmlzpos5,logmlzpos6,logmlzpos7,logmlzpos8,logmlzpos9,logmlzpos10,logmlzpos11,logmlzpos12,logmlzpos13,logmlzpos14,logmlzpos15,logmlzpos16,logmlzpos17,logmlzpos18,logmlzpos19,logmlzpos20,logmlzpos21,logmlzpos22,logmlzpos23,logmlzpos24,logmlzpos25,logmlzpos26,logmlzpos27,logmlzpos28,logmlzpos29,logmlzpos30,logmlzpos31,logmlzpos32,logmlzpos33,logmlzpos34,logmlzpos35,logmlzpos36] 

logmlzpos_t = list(reversed(logmlzpos_t))
#logmlzpos_t2 = []

# create data
np.random.seed(19680801)

logmlzpost = []

for i in range(0,36):
    lmp = sorted(logmlzpos_t[i])
    logmlzpost.append(lmp) 

fig, ax = plt.subplots(nrows=1, ncols=1, figsize=(15,40),dpi=300,tight_layout=True, sharex = True)

ax.axvline(x=1,color='#deddd3',zorder=0)
ax.axvline(x=2,color='#deddd3',zorder=0)
ax.axvline(x=3,color='#deddd3',zorder=0)
ax.axvline(x=4,color='#deddd3',zorder=0)
ax.set_xlim(0,5)
ax.spines["bottom"].set_visible(False)
ax.spines["top"].set_visible(False)
ax.spines["left"].set_visible(False)
ax.spines["right"].set_visible(False)
ax.xaxis.grid(True, which='minor')
ax.yaxis.grid(True, which='minor')
ax.tick_params(labelsize=24)
part = ax.violinplot(logmlzpost,widths=0.4,vert=False)

part = ax.violinplot(logmlzpost,widths=0.4,vert=False)
for pc in part['bodies']:
    pc.set_facecolor('#52acfa')
    pc.set_edgecolor('black')
    pc.set_alpha(0.8)

for partname in ('cbars','cmins','cmaxes'): #'cmedians'
    vp1 = part[partname]
    vp1.set_edgecolor('black')
    vp1.set_linewidth(1.0)

#The Bayes factors are precalculated by hand and be written.
labels1 = ['GW190408_181802','GW190412','GW190413_052954','GW190413_134308','GW190421_213856', 'GW190424_180648','GW190503_185404','GW190512_180714','GW190513_205428','GW190514_065416','GW190517_055101','GW190519_153544','GW190521',
'GW190521_074359','GW190527_092055','GW190602_175927','GW190620_030421','GW190630_185205','GW190701_203306','GW190706_222641','GW190707_093326',
'GW190708_232457','GW190719_215514','GW190720_000836','GW190727_060333','GW190728_064510','GW190731_140936','GW190803_022701','GW190828_063405',
'GW190828_065509','GW190909_114149','GW190910_112807','GW190915_235702','GW190924_021846','GW190929_012149','GW190930_133541'] 

B_F= np.loadtxt('Sec_6_Figure_5_BF.dat')
labels1R = round(B_F,1)
labels1 = list(reversed(labels1))
labels1R = list(reversed(labels1R))
#labels2 = []
#labels2R = []
set_axis_style1(ax, labels1,labels1R)

#plt.subplots_adjust(bottom=0.2, hspace=0.15)
plt.savefig('Sec_6_Figure_5.pdf',dpi=300,bbox_inches='tight')